;===========================================================================
;
; RAFIX.ASM - DOS patch to make Red Alert Counterstrike & The Aftermath run
;             in an OS/2 DOS fullscreen session.
;
; (C)1999 Robert Basler
;
;===========================================================================

_text	segment word public 'code'

; Devicedriver is defined in the batch files used to compile this file. If
; compiled by b.bat, devicedriver is defined with the /d option.  If compiled
; by c.bat, it is not defined.

;include modules.asm

ifdef devicedriver
	assume cs:_text,ds:_text,es:_text

; code if are compiling to a device driver

	org 0
start:
        maxcmd	equ 24 	; max allowed command code
Header:			; device driver header
	dd	-1	; link to next device driver
	dw	0c840h	; device attribute word
	dw	Strat	; pointer to strategy routine
	dw	Intr	; 	     interrupt routine
sig	db	"RAOS2FIX" 	; device name
RHPtr	dd	?	; pointer to request header

Dispatch:
	dw	init	;0
	dw	none
	dw	none
	dw	none
	dw	none
	dw	none
	dw	none
	dw	none
	dw	none	;8
	dw	none
	dw	none
	dw	none
	dw	none
	dw	none
	dw	none
	dw	none
	dw	none	;16
	dw	error
	dw	error
	dw 	none
	dw	error
	dw	error
	dw	error
	dw	none
	dw 	none	;24

Strat proc	far	; device driver strategy routine
	mov	word ptr cs:[rhptr],bx
	mov	word ptr cs:[rhptr+2],es
	ret
Strat endp

Intr	proc	far	; device driver interrupt routine
	push	ds
	push	di
	push	bx
	push	ax
	push	es
	push	dx
	push	cs	; make ds addressable
	pop	ds
	les	di,[rhptr]
	mov	bl,es:[di+2]	; get command code
	xor	bh,bh
	cmp	bx,maxcmd
	jle	intr1
	call	error
	jmp	intr2
intr1:
	shl	bx,1
	call	word ptr [bx+dispatch]
	les	di,[rhptr]
intr2:
	or	ax,100h	; set done bit
	mov	es:[di+3],ax

	pop	dx
	pop	es
	pop	ax
	pop	bx
	pop	di
	pop	ds
	ret
intr	endp

none	proc	near
	xor	ax,ax
	ret
none	endp

Error	proc	near
	mov	ax,8003h	; error bit + unknown command code
	ret
Error 	endp

else

; code if are compiling to a .com file.
	assume cs:_text,ds:_text,es:_text

org 100h

start:
     jmp init
; this will give us a signature to search for.
org 10ah
sig db "RAOS2FIX"
endif

csint9     dd ?          ; original int9 handler address

int9 proc far
        pushf
        ; check for findfirst call
        cmp ah,4eh
        jne NotIt
        ; check that are checking volume label
        cmp cx,8
        jne NotIt
        ; check that parameter is D:\NULL
        push bx
        mov bx,dx
        cmp byte ptr [bx+3],0
        pop bx
        je isfindfirst
NotIt:
        popf
        ; nope, not our call, call original handler
        jmp     cs:csint9
isfindfirst:
        ; hope this doesn't corrupt anything important
        push bx
        push cx
        mov bx,dx
        mov cx,word ptr [bx+3]
        mov byte ptr [bx+3],'*'
        mov byte ptr [bx+4],0
        push cx
        pushf
        mov cx,8
        call cs:csint9
        pop cx
        ; fix the original calling parameter
        mov [bx+3],cx
        ; move return address to one word up in the stack so can do retf
        ; rather than iret and not get flags left on stack.
        mov bx,sp
        mov cx,ss:[bx+8]
        mov ss:[bx+10],cx
        mov cx,ss:[bx+6]
        mov ss:[bx+8],cx
        pop cx
        pop bx
        ; get our saved flags off of stack
        inc sp
        inc sp
        ; fix sp so points at return address now that we moved the address on the stack
        inc sp
        inc sp
        retf
int9	endp

residentsize label byte

Init	proc	near
        push    ax
        push    bx
        push    es
        push    ds
        push    dx

        push    cs        ; make our ds addressable
        pop     ds

        ; output the titles for the device driver.
        mov     ah,9h
        mov     dx,offset BiosTitles
        int     21h

        ; yes, install int9 handler to work it.
        xor     bx,bx
        mov     es,bx
        mov     bx,21h*4
        cli
        mov     ax,es:[bx]
        mov     word ptr cs:csint9,ax
        mov     ax,es:[bx+2]
        mov     word ptr cs:csint9+2,ax
        mov     word ptr es:[bx],offset int9
        mov     word ptr es:[bx+2],cs
        sti

        mov     ah,9
        mov     dx,offset int154fmsg
        int     21h

        mov     [sig+6],'D'    ; set signature to indicate installed
        pop     dx
        pop     ds
        pop     es
        pop     bx
        pop     ax

ifdef devicedriver
	mov	word ptr es:[di+14],offset residentsize
	mov	word ptr es:[di+16],cs
	xor	ax,ax
	ret
else
        ; DEALLOCATE THE PROGRAM'S ENVIRONMENT BLOCK

	MOV	AX,DS:[2CH]		; GET ENVT SEGMENT
	MOV	ES,AX
	MOV	AH,49H			; FREE IT
	INT	21H

        mov     dx,offset residentsize
        add     dx,15
        mov     cx,4
        shr     dx,cl            ; terminate and stay resident
        mov     ax,3100h
        int     21h
endif
Init	endp

BiosTitles db 13,10,"Command & Conquer Red Alert Fix for OS/2 Warp 4.0",13,10
           db "Version 1.02 Copyright (c)1999 Robert Basler (aurorasw@direct.ca)",13,10,13,10,"$"

int154fmsg db "Fix installed.",13,10,"Counterstrike and The Aftermath will now work in this OS/2 Warp DOS",13,10,"Fullscreen Session.",13,10,13,10,"Don't forget to use the -CDx: parameter when starting RA.EXE where x is",13,10,"the drive letter of your CD-ROM.",13,10,"$"

_text ends

end start
